"""
    REST API

    Rockset's REST API allows for creating and managing all resources in Rockset. Each supported endpoint is documented below.  All requests must be authorized with a Rockset API key, which can be created in the [Rockset console](https://console.rockset.com). The API key must be provided as `ApiKey <api_key>` in the `Authorization` request header. For example: ``` Authorization: ApiKey aB35kDjg93J5nsf4GjwMeErAVd832F7ad4vhsW1S02kfZiab42sTsfW5Sxt25asT ```  All endpoints are only accessible via https.  Build something awesome!  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from rockset_v2.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from rockset_v2.exceptions import ApiAttributeError


def lazy_import():
    from rockset_v2.model.azure_blob_storage_integration import AzureBlobStorageIntegration
    from rockset_v2.model.azure_event_hubs_integration import AzureEventHubsIntegration
    from rockset_v2.model.dynamodb_integration import DynamodbIntegration
    from rockset_v2.model.gcs_integration import GcsIntegration
    from rockset_v2.model.kafka_integration import KafkaIntegration
    from rockset_v2.model.kinesis_integration import KinesisIntegration
    from rockset_v2.model.mongo_db_integration import MongoDbIntegration
    from rockset_v2.model.s3_integration import S3Integration
    from rockset_v2.model.segment_integration import SegmentIntegration
    globals()['AzureBlobStorageIntegration'] = AzureBlobStorageIntegration
    globals()['AzureEventHubsIntegration'] = AzureEventHubsIntegration
    globals()['DynamodbIntegration'] = DynamodbIntegration
    globals()['GcsIntegration'] = GcsIntegration
    globals()['KafkaIntegration'] = KafkaIntegration
    globals()['KinesisIntegration'] = KinesisIntegration
    globals()['MongoDbIntegration'] = MongoDbIntegration
    globals()['S3Integration'] = S3Integration
    globals()['SegmentIntegration'] = SegmentIntegration


class CreateIntegrationRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """
    
    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'name': (str,),  # noqa: E501
            'azure_blob_storage': (AzureBlobStorageIntegration, none_type),  # noqa: E501
            'azure_event_hubs': (AzureEventHubsIntegration, none_type),  # noqa: E501
            'description': (str, none_type),  # noqa: E501
            'dynamodb': (DynamodbIntegration, none_type),  # noqa: E501
            'gcs': (GcsIntegration, none_type),  # noqa: E501
            'kafka': (KafkaIntegration, none_type),  # noqa: E501
            'kinesis': (KinesisIntegration, none_type),  # noqa: E501
            'mongodb': (MongoDbIntegration, none_type),  # noqa: E501
            's3': (S3Integration, none_type),  # noqa: E501
            'segment': (SegmentIntegration, none_type),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'name': 'name',  # noqa: E501
        'azure_blob_storage': 'azure_blob_storage',  # noqa: E501
        'azure_event_hubs': 'azure_event_hubs',  # noqa: E501
        'description': 'description',  # noqa: E501
        'dynamodb': 'dynamodb',  # noqa: E501
        'gcs': 'gcs',  # noqa: E501
        'kafka': 'kafka',  # noqa: E501
        'kinesis': 'kinesis',  # noqa: E501
        'mongodb': 'mongodb',  # noqa: E501
        's3': 's3',  # noqa: E501
        'segment': 'segment',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, name, *args, **kwargs):  # noqa: E501
        """CreateIntegrationRequest - a model defined in OpenAPI

        Args:
            name (str): descriptive label

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            azure_blob_storage (AzureBlobStorageIntegration): [optional]  # noqa: E501
            azure_event_hubs (AzureEventHubsIntegration): [optional]  # noqa: E501
            description (str): longer explanation for the integration. [optional]  # noqa: E501
            dynamodb (DynamodbIntegration): [optional]  # noqa: E501
            gcs (GcsIntegration): [optional]  # noqa: E501
            kafka (KafkaIntegration): [optional]  # noqa: E501
            kinesis (KinesisIntegration): [optional]  # noqa: E501
            mongodb (MongoDbIntegration): [optional]  # noqa: E501
            s3 (S3Integration): [optional]  # noqa: E501
            segment (SegmentIntegration): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.name = name
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *, name, **kwargs):  # noqa: E501
        """CreateIntegrationRequest - a model defined in OpenAPI

        Keyword Args:
            name (str): descriptive label
            azure_blob_storage (AzureBlobStorageIntegration): [optional]  # noqa: E501
            azure_event_hubs (AzureEventHubsIntegration): [optional]  # noqa: E501
            description (str): longer explanation for the integration. [optional]  # noqa: E501
            dynamodb (DynamodbIntegration): [optional]  # noqa: E501
            gcs (GcsIntegration): [optional]  # noqa: E501
            kafka (KafkaIntegration): [optional]  # noqa: E501
            kinesis (KinesisIntegration): [optional]  # noqa: E501
            mongodb (MongoDbIntegration): [optional]  # noqa: E501
            s3 (S3Integration): [optional]  # noqa: E501
            segment (SegmentIntegration): [optional]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """
        
        args = []
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.name = name
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            # todo: remove these comments - this stops the user from setting read only vars but we need this now to address a bug
            # if var_name in self.read_only_vars:
            #     raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
            #                          f"class with read only attributes.")
